> ## Documentation Index
> Fetch the complete documentation index at: https://openworklabs.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update the tool policy for an External MCP Connection



## OpenAPI

````yaml /openapi.json put /v1/mcp-connections/{connectionId}/tool-policy
openapi: 3.1.0
info:
  title: Den API
  description: >-
    OpenAPI spec for the Den control plane API.


    Authentication:

    - Use `Authorization: Bearer <session-token>` for user-authenticated routes
    that require a Den session.

    - Use `x-api-key: <den-api-key>` for API-key-authenticated routes that
    accept organization API keys.

    - Public routes like health and documentation do not require authentication.


    Swagger tip: use the security schemes in the Authorize dialog to set either
    `bearerAuth` or `denApiKey` before trying protected endpoints.
  version: dev
servers:
  - url: http://api.den.local
security: []
tags:
  - name: System
    description: Service health and operational routes.
  - name: Organizations
    description: Top-level organization creation and context routes.
  - name: Invitations
    description: Invitation preview, acceptance, creation, and cancellation routes.
  - name: API Keys
    description: Organization API key management routes.
  - name: SCIM
    description: Organization SCIM connector management routes.
  - name: SSO
    description: Organization single sign-on connector management routes.
  - name: Members
    description: Organization member management routes.
  - name: Roles
    description: Organization custom role management routes.
  - name: Teams
    description: Organization team management routes.
  - name: Templates
    description: Organization shared template routes.
  - name: LLM Providers
    description: Organization LLM provider catalog, configuration, and access routes.
  - name: Workers
    description: Worker lifecycle, billing, and runtime routes.
  - name: Worker Runtime
    description: Worker runtime inspection and upgrade routes.
  - name: Worker Activity
    description: Worker heartbeat and activity reporting routes.
  - name: Telemetry
    description: Telemetry event ingestion and adoption analytics.
  - name: Admin
    description: Administrative reporting routes.
  - name: Users
    description: Current user and membership routes.
  - name: Bootstrap
    description: Agent-first provisional workspace setup routes.
paths:
  /v1/mcp-connections/{connectionId}/tool-policy:
    put:
      tags:
        - Capability Sources
      summary: Update the tool policy for an External MCP Connection
      operationId: putV1McpConnectionsByConnectionIdToolPolicy
      parameters:
        - in: path
          name: connectionId
          schema:
            format: typeid
            type: string
            minLength: 30
            maxLength: 30
          required: true
          description: Den TypeID with 'emc_' prefix and a 26-character base32 suffix.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ExternalMcpConnectionToolPolicyInput'
      responses:
        '200':
          description: External MCP tool policy updated.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ExternalMcpConnectionToolPolicyResponse'
        '401':
          description: The caller must be signed in.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthorizedError'
        '403':
          description: The caller must be a workspace owner or admin.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenError'
        '404':
          description: Unknown connection.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ExternalMcpConnectionNotFoundError'
components:
  schemas:
    ExternalMcpConnectionToolPolicyInput:
      type: object
      properties:
        allDisabled:
          type: boolean
        disabledTools:
          maxItems: 500
          type: array
          items:
            type: string
            minLength: 1
            maxLength: 255
      required:
        - allDisabled
        - disabledTools
    ExternalMcpConnectionToolPolicyResponse:
      type: object
      properties:
        policy:
          $ref: '#/components/schemas/ExternalMcpConnectionToolPolicy'
      required:
        - policy
    UnauthorizedError:
      type: object
      properties:
        error:
          type: string
          const: unauthorized
      required:
        - error
    ForbiddenError:
      type: object
      properties:
        error:
          type: string
          enum:
            - forbidden
            - reauth
        reason:
          type: string
        message:
          type: string
      required:
        - error
    ExternalMcpConnectionNotFoundError:
      type: object
      properties:
        error:
          type: string
          const: connection_not_found
        message:
          type: string
      required:
        - error
        - message
    ExternalMcpConnectionToolPolicy:
      type: object
      properties:
        allDisabled:
          type: boolean
        disabledTools:
          type: array
          items:
            type: string
        updatedBy:
          anyOf:
            - type: string
            - type: 'null'
        updatedAt:
          anyOf:
            - type: string
              format: date-time
              pattern: >-
                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
            - type: 'null'
      required:
        - allDisabled
        - disabledTools
        - updatedBy
        - updatedAt

````